import sys
import os
import shutil


print( sys.argv )

assert( len( sys.argv ) == 4  )

x64_folder = sys.argv[ 1 ]
old_x86_folder = sys.argv[ 2 ]
new_x86_folder = sys.argv[ 3 ]
for folder in [ x64_folder,  old_x86_folder ]:
    if not os.path.exists( folder ):
        print( "'%s' does not exist." % folder )
        exit()

if not ( old_x86_folder.find( 'Released' ) >= 0 and old_x86_folder.find( 'x86' ) >= 0 ):
    print( "Path name '%s' is not appropriate." % old_x86_folder )
    exit()

if not new_x86_folder.find( 'x86' ) >= 0:
    print( "New path name '%s' is not appropriate." % new_x86_folder )
    exit()

if os.path.exists( new_x86_folder ):
    print( "'%s' exists. May I remove it? (y/[n]) >" % new_x86_folder )
    reply = sys.stdin.readline()
    if reply[0] != 'y':
        exit()
    shutil.rmtree( new_x86_folder )

print( "Copying '%s' to '%s'" % ( x64_folder, new_x86_folder ) )
shutil.copytree( x64_folder, new_x86_folder )

for folder in [ 'lib/tkdnd2.8', 'lib/tktable-2.11.kek', 'synthesizer' ]:
    new_path_ = new_x86_folder + '/' + folder
    old_path_ = old_x86_folder + '/' + folder
    print( "Removing '%s'" % ( new_path_ ) )
    shutil.rmtree( new_path_ )
    print( "Copying '%s'" % ( old_path_ ) )
    shutil.copytree( old_path_, new_path_ )

print( 'Finished.' )
