# -*- coding: utf-8 -*-
"""

    ファイル名：   BasicUtils.py

    処理内容：

        テスト

"""

from __future__ import division, print_function, unicode_literals

import sys
import os
import getpass
import time
import shutil

def mkdirs_with_retry( path, retry=3 ):
    retry_ = 0
    while( not os.path.exists( path ) ):
        try:
            os.makedirs( path )
        except:
            if retry_ < retry:
                retry_ += 1
                time.sleep( 1 )
                print( 'retry os.makedirs( %s )' % ( path ) )
            else:
                assert( False )

def clear_dirs_with_retry( dirs, retry=3  ):
    for dir_ in dirs:
        if os.path.exists( dir_ ):
            shutil.rmtree( dir_ )
        mkdirs_with_retry( dir_, retry=retry )

def rename_with_retry( old_path, new_path, retry=3 ):
    retry_ = 0
    done_ = False
    while( not done_ ):
        try:
            os.rename( old_path, new_path )
            done_ = True
        except:
            if retry_ < retry:
                retry_ += 1
                time.sleep( 1 )
                print( 'retry os.rename( %s, %s )' % ( old_path, new_path ) )
            else:
                assert( False )

def exe_name():
    name_ =  os.path.split( sys.argv[0] )[-1]
    for ext in ( '.exe', '.py' ):
        name_ = name_.replace( ext, '' )
    return name_

def home_dir():
    username = getpass.getuser()
    return os.path.expanduser( '~' + username )

"""
    URL: http://stackoverflow.com/questions/1305532/convert-python-dict-to-object

    namedtuple の場合、メンバーの更新は can't set attritube により不可のようなので
    この Struct の方が柔軟。
"""
class Struct:
    def __init__(self, **entries): 
        self.__dict__.update(entries)
